#----------------------------------------------------------------------
#                      TP03 - Lois discretes -Binomiale et Poisson-
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#                       Exercise 1.1
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
X <- function() ifelse(rbinom(1,1,0.5),"PILE","FACE")
X()
#----------------------- question 2 -----------------------------------
lancer.le.de <- function() sample(1:6,1)
lancer.le.de()
#----------------------- question 3 -----------------------------------
yams <- function() sample(1:6,size=5,replace=TRUE)
#----------------------- question 4 -----------------------------------
n <- 10000
result <- replicate(n,yams(),TRUE)
test <- function(res) ifelse(length(unique(res))> 1,0,1)
prop <- mean(apply(result,MARGIN=2,FUN=test))


#----------------------------------------------------------------------
#                       Exercise 1.2
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
# Assuming that the outcomes (success or failure) of the 5 attempts
# are independent, the number of successes follows the binomial distribution
# with parameters
n <- 5; p <- 0.9
# The random variable X takes its values in the set {0,1,2,3,4,5}.
d <- dbinom(0:5,n,p); d                     # probabilities
sum(d)                                      # they add up to 1
#----------------------- question 2 -----------------------------------
n*p                                         # expectation
n*p*(1-p)                                   # variance
sqrt(n*p*(1-p))                             # standard-deviation
qbinom(0.5,n,p)                             # median
qbinom(0.25,n,p)                            # first quartile
qbinom(0.75,n,p)                            # third quartile
#----------------------- question 3 -----------------------------------
dbinom(5,n,p)                               # exactly 5 times
dbinom(3,n,p)                               # exactly 3 times
sum(dbinom(0:3,n,p))                        # at most 3 times
pbinom(3,n,p)                               # same result
sum(dbinom(3:5,n,p))                        # at least 3 times
pbinom(2,n,p,lower.tail=FALSE)              # same result
sum(dbinom(2:4,n,p))                        # from 2 to 4 times
pbinom(4,n,p)-pbinom(1,n,p)                 # same result
#----------------------- question 4 -----------------------------------
N <- 100                                    # sample size
x <- rbinom(N,n,p)                          # random sample
table(x)/N                                  # relative frequencies


#----------------------------------------------------------------------
#                        Exercise 1.3
#----------------------------------------------------------------------
#----------------------- question 1 ----------------------------------
sample(0:1,10,replace = TRUE,prob=c(0.25,0.75)) #genere un echantillon detaille 10 de 0 et 1, 0 apparait avec la proba 0.25 et 1 avec 0.75 (au final cela genere une loi de bernouli B(0.25))
rbinom(20,1,0.5) #Genere un 20 echantillon de Binomiale B(1,0.5) soit une bernoulli B(0.5)
rnbinom(15,10,0.45) ##Genere un 15 echantillon de loi negative binomiale
#----------------------- question 2 ----------------------------------
sample(1:6,10,replace = TRUE,prob=c(1/6,1/6,1/6,1/6,1/6,1/6)) 
rbinom(10,5,0.5)
rpois(10,3)
rgeom(10,0.1)
#----------------------- question 3 ----------------------------------
sample(0:3,10,replace = TRUE,prob=c(10*9*8/(15*14*13),3*10*9*5/(15*14*13),3*5*4*10/(15*14*13),5*4*3/(15*14*13))) 
#----------------------- question 4 ----------------------------------
x = sample(c(0, 2, 5), 1000, replace = T, prob = c(0.2, 0.5, 0.3))
table(x)


#----------------------------------------------------------------------
#                        Exercise 1.4
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
dbinom(0,6,1/4)                             # none of the witnesses
dbinom(1,6,1/4)                             # exactement un
pbinom(1,6,1/4,lower.tail=FALSE)            # deux ou plus
#----------------------- question 2 -----------------------------------
# the probability to be identified by 2 or more witnesses is 0.466:
# yes, this might be due to chance.
#----------------------- question 3 -----------------------------------
pbinom(3,6,1/4,lower.tail=FALSE)            # 4 witnesses or more
# the result is 0.0376: this is a small probability, the judge has all
# reasons to be suspicious.


#----------------------------------------------------------------------
#                        Exercise 1.5
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
plot(0:8, dpois(0:8, 1), type = "h", xlab = "x", ylab = "P(X = x)")
#----------------------- question 2 -----------------------------------
simul2 = rpois(1000, 1)
#----------------------- question 3 -----------------------------------
hist(simul2, col = 3, prob = TRUE, ylim = c(0, 0.9),main = "Histogramme de rpois(1000, 1)")
x=seq(0,1,7)
y <- dpois(x,1) 
plot(x, y,type="h",lwd = 15, main = "Densité Poisson P(1)", ylab = "p(x)",lend ="square")
#----------------------- question 4 -----------------------------------
boxplot(simul2, main = "Boxplot de rpois(1000, 1)")


#----------------------------------------------------------------------
#                        Exercise 1.6
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
help(rpois)
#----------------------- question 2 -----------------------------------
rpois(10,5)
rpois(25,15)
#
dpois(-1,5)
dpois(-1,15)
ppois(-1,5)
ppois(-1,15)

dpois(4,5)
dpois(4,15)
ppois(4,5)
ppois(4,15)

dpois(13,5)
dpois(13,15)
ppois(13,5)
ppois(13,15)

#
qpois(0.1,5)
qpois(0.1,15)
qpois(0.75,5)
qpois(0.75,15)

#
x=seq(0,20)
x
plot(x,dpois(x,1))
plot(x,dpois(x,3))
plot(x,dpois(x,12))
#----------------------- question 3 -----------------------------------
x=rpois(5,10)
#Pour se faire une idée de l'allure de ce tableau, taper :
x
table(x) #calcule les effectifs

eff<-table(x)

#Le diagramme en bâtons de nos données s'obtient à l'aide de la commande suivante:
barplot(eff, main = "Diagramme en bâtons", xlab = "score", ylab =
"effectif")
#Les arguments main, xlab et ylab sont optionnels.
#- main permet de définir un titre;
#- xlab permet de nommer l'axe des x (horizontal);
#- ylab permet de nommer l'axe des y (vertical).

x=rpois(50,10)
eff<-table(x)
barplot(eff,main = "Diagramme en bâtons", xlab = "score", ylab =
"effectif")

x=rpois(500,10)
eff<-table(x)
plot(eff,main = "Diagramme en bâtons", xlab = "score", ylab =
"effectif")


#----------------------------------------------------------------------
#                        Exercise 1.7
#----------------------------------------------------------------------
dpois(0,1)
1-ppois(3,1)
ppois(2,1)


#----------------------------------------------------------------------
#                        Exercise 1.8
#----------------------------------------------------------------------
dpois(0,6)
ppois(6,6)


#----------------------------------------------------------------------
#                        Exercise 1.9
#----------------------------------------------------------------------
p=1/76000000
p
n=40000000
dbinom(0,n,p)
dbinom(1,n,p)
dbinom(2,n,p)
dbinom(10,n,p)

a=n*p
dpois(0,a)
dpois(1,a)
dpois(2,a)
dpois(10,a)

dbinom(5,10,0.5)
dpois(5,5)


