#----------------------------------------------------------------------
#                      TP05 - Loi Normale
#----------------------------------------------------------------------


#----------------------------------------------------------------------
#                       Exercise 1.1
#----------------------------------------------------------------------
x=seq(from=4,to=16,by=0.1)
plot(x,dnorm(x,,mean=10,sd=2),type="l",ylab="fonction de densité")
curve(pnorm(x,10,2),from=4,to=16,ylab="fonction de repartition")


#----------------------------------------------------------------------
#                       Exercise 1.2
#----------------------------------------------------------------------
par(mfrow = c(3, 1))
curve(dnorm(x, 4, 1), 1, 8, ylab = "",
main = "Densités associées aux lois N(4,1) et N(5,1)")
curve(dnorm(x, 5, 1), 1, 8, col = 3, ylab = "", add = TRUE)
curve(dnorm(x, 4, 1), -2, 10, ylab = "",
main = "Densités associées aux lois N(4,1) et N(4,4)")
curve(dnorm(x, 4, 2), -2, 10, col = 3, ylab = "", add = TRUE)
curve(dnorm(x, 4, 1), -1, 11, ylab = "",
main = "Densités associées aux lois N(4,1) et N(5,4)")
curve(dnorm(x, 5, 2),-1, 11, col = 3, ylab = "", add = TRUE)
par(mfrow = c(1,1))


#----------------------------------------------------------------------
#                       Exercise 1.3
#----------------------------------------------------------------------
curve(dnorm(x, 0, 1), xlim = c(-10, 10), ylim = c(0, 0.58), col = "red", lwd = 3,
ylab = "", main = "Exemples de densités associées à la loi normale")
curve(dnorm(x, 2, 3), col = "green", lwd = 3, add = TRUE)
curve(dnorm(x, 0, 5), col = "blue", lwd = 3, add = TRUE)
curve(dnorm(x, -2, 0.7), col = "yellow", lwd = 3, add = TRUE)
legend("topright", legend = c("N(0,1)", "N(2,9)", "N(0,25)", "N(-2,0.49)"),
lty = 1, lwd = 3, col = c("red", "green", "blue", "yellow"))


#----------------------------------------------------------------------
#                       Exercise 1.4
#----------------------------------------------------------------------
pnorm(650, 550, 100)
1-pnorm(746, 550, 100)
pnorm(746, 550, 100, lower.tail = FALSE) #au choix
pnorm(600, 550, 100) - pnorm(550, 550, 100)


#----------------------------------------------------------------------
#                       Exercise 1.5
#----------------------------------------------------------------------
x<-rnorm(500,mean=50,sd=3) 
y<-(x-50)/3
hist(x)
hist(x,breaks=8,probability = T)
lines(density(x),col="red")
plot(density(y),col="red",type="l",xlab="y",ylab="densité",main="")
z=seq(-3,3,0.1)
lines(z,dnorm(z),col="blue")
legend(-3.5, 0.3, legend=c("Experience","Theorie"),col=c("red", "blue"), lty=1:2, cex=0.8)
plot.ecdf(y,col = "red")
lines(z,pnorm(z),col="blue")


#----------------------------------------------------------------------
#                       Exercise 1.6
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
densnorm = function(x) {(1 / sqrt(2 * pi)) * exp(-x^2 / 2)}
#----------------------- question 2 -----------------------------------
integrate(function(x) dnorm(x), -100, 100)
#----------------------- question 3 -----------------------------------
par(mfrow = c(1, 2))
curve(dnorm(x), -5, 5, ylab = "Densité")
curve(pnorm(x), -5, 5, ylab = "Fonction de répartition")
#----------------------- question 4 -----------------------------------
pnorm(2.2)
1 - pnorm(1.7)
pnorm(1.7, lower.tail = FALSE) #alternative
pnorm(1.4) - pnorm(0.2)
2 * pnorm(1.96) - 1 #P(|X| ≤ 1.96) = 2P(X ≤ 1.96) − 1
#----------------------- question 5 -----------------------------------
qnorm(0.98)


#----------------------------------------------------------------------
#                       Exercise 1.7
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
mc <- 2970; sdc <- 251                      # donnees pour la population temoins
mr <- 3350; sdr <- 223                      # donnees pour les courreurs
                       # temoin
pnorm(3000,mc,sdc)                          # moins de 3000
pnorm(3000,mc,sdc,lower.tail=FALSE)         # plus de 3000
#----------------------- question 2 -----------------------------------
pnorm(2600,mc,sdc)                          # moins de 2600
pnorm(3400,mc,sdc,lower.tail=FALSE)         # plus de 4000
pnorm(3400,mc,sdc)-pnorm(2600,mc,sdc)       # entre 2600 et 3400
#----------------------- question 3 -----------------------------------
qnorm(0.01,mc,sdc)                          # temoin population 1% plus petit
qnorm(0.01,mr,sdr,lower.tail=FALSE)         # runner 1% plus grand

xlim <- c(2350,3900)                        # bounds pour graphics
{curve(dnorm(x,mc,sdc),                     # density pour temoin
       col="blue",xlim=xlim)}
{curve(dnorm(x,mr,sdr),                     # density pour runers
     col="red",add=TRUE)}
abline(v=2600,col="green")                  # vertical line at 2600
abline(v=3400,col="green")                  # vertical line at 3400
#----------------------- question 4 -----------------------------------
qnorm(0.05,mc,sdc)                          # temoin 5% plus petit
qnorm(0.01,mc,sdc,lower.tail=FALSE)         # temoin 5% plus grand
#----------------------- question 5 -----------------------------------
{curve(pnorm(x,mc,sdc),                     # cdf pour temoin
       col="blue",xlim=xlim)}
{curve(pnorm(x,mr,sdr),                     # cdf pour courreurs
     col="red",add=TRUE)}
abline(v=2600,col="green")                  # ligne verticale at 2600
abline(v=3400,col="green")                  # ligne verticale at 3400
#----------------------- question 6 -----------------------------------
                       # temoin
qnorm(0.4,mc,sdc)                           # quantile d’ordre 0.4
qnorm(0.8,mc,sdc)                           # 80% plus petit
#----------------------- question 7 -----------------------------------
# La différence temoins moins coureur a une distribution normale avec les paramètres suivants
md <- mc-mr; md                             # moyenne difference
sdd <- sqrt(sdc^2+sdr^2); sdd               # ecart-type de la difference
lb <- qnorm(0.01,md,sdd); lb                # limite inférieure
ub <- qnorm(0.01,md,sdd,lower.tail=FALSE);ub# limite superieure
curve(dnorm(x,md,sdd),xlim=c(lb,ub))        # densite de la difference
abline(v=c(0,-400),col="green")             # ajouter lignes verticales
pnorm(0,md,sdd)                             # risques d'une différence négative
pnorm(-400,md,sdd)                          # courreurs mangent plus par 400 Kcal