#----------------------------------------------------------------------
#                      TP06 - Loi des grands nombres
#----------------------------------------------------------------------


#----------------------------------------------------------------------
#                       Exercise 1.1
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
echantillon=rbinom(n=1000,size=1,prob=.3)
#----------------------- question 2 -----------------------------------
plot(cumsum(echantillon)/(1:1000),type='l',main='Loi des grands nombres',ylim=c(0,0.7),xlab='Taille échantillon')
abline(h=.3,col=2)
legend(x='top',lty=1, col=1:2,legend=c('fréquence empirique de 1','probabilité de 1'),bty='n')
#----------------------- question 3 -----------------------------------
echantillon=rbinom(n=40000,size=1,prob=.3)
plot(cumsum(echantillon)/(1:40000),type='l',main='Loi des grands nombres',ylim=c(0,0.7),xlab='Taille échantillon')
abline(h=.3,col=2)
legend(x='top',lty=1, col=1:2,legend=c('fréquence empirique de 1','probabilité de 1'),bty='n')
#Pour n<=500, il y a de grandes fluctuation
#Pour n>2000, les fluctuation de la moyenne empirique autour de la moyenne theorique ne sont plus visible (à moins de zoomer)

#----------------------------------------------------------------------
#                       Exercise 1.2
#----------------------------------------------------------------------


#----------------------- question 1 -----------------------------------
# En supposant que les résultats (succès ou échec) des 5 tentatives sont indépendants, le nombre de succès suit la distribution binomiale avec les paramètres suivants
n <- 5; p <- 0.9
# La variable aléatoire X prend ses valeurs dans l'ensemble {0,1,2,2,3,4,5}.
d <- dbinom(0:5,n,p); d                     # probabilites
sum(d)                                      # elles totalisent 1
#----------------------- question 2 -----------------------------------
n*p                                         # expectation
n*p*(1-p)                                   # variance
sqrt(n*p*(1-p))                             # standard-deviation
qbinom(0.5,n,p)                             # median
qbinom(0.25,n,p)                            # premier quartile
qbinom(0.75,n,p)                            # troisième quartile
#----------------------- question 3 -----------------------------------
dbinom(5,n,p)                               # exactement 5 fois
dbinom(3,n,p)                               # exactement 3 fois
sum(dbinom(0:3,n,p))                        # au plus3 fois
pbinom(3,n,p)                               # meme resultat
sum(dbinom(3:5,n,p))                        # au moins 3 fois
pbinom(2,n,p,lower.tail=FALSE)              # meme resultat
sum(dbinom(2:4,n,p))                        # de 2 jusqu'à 4 fois
pbinom(4,n,p)-pbinom(1,n,p)                 # meme resultat
#----------------------- question 4 -----------------------------------
N <- 100                                    # taille de l'echantillon 
x <- rbinom(N,n,p)                          # echantillon aléatoire
table(x)/N                                  # frequences relatives
#----------------------- question 5 -----------------------------------
N <- 1e4                                    # taille de l'echantillon 
n <- 5; p <- 0.9                            # parametres
x <- rbinom(N,n,p)                          # echantillon aléatoire
plot(ecdf(x),col="blue")                    # Empirical Cumulative Distribution Function.
points(0:5,pbinom(0:5,n,p),col="red")       # probabilites cumulees 
#----------------------- question 6 -----------------------------------
xm <- cumsum(x)/(1:N)                       # partial empirical means
plot(1:N,xm,pch=".",col="blue")             # tracer comme des points bleus
abline(h=n*p,col="red")                     # attente réelle
#----------------------- question 7 -----------------------------------
y <-  ifelse(x<=3,1,0)                      # variable binaire
yf <- cumsum(y)/(1:N)                       # partial relative frequencies
plot(1:N,yf,pch=".",col="blue")             # tracer comme des points bleus
abline(h=pbinom(3,n,p),col="red")           #  attente réelle




#----------------------------------------------------------------------
#                        Exercise 1.3
#----------------------------------------------------------------------
#----------------------- question 1 -----------------------------------
TA <- read.table("data/TP06_tauber.csv",header=TRUE,sep=";")
H <- TA[,"height"]
sum(H>110)
sum(H<=110)
#----------------------- question 2 -----------------------------------
n <- length(H)
plot(1:n,cumsum(H>110)/(1:n),pch=".",ylim=c(0,1))
#----------------------- question 3 -----------------------------------
rH <- sample(H)
points(1:n,cumsum(rH>110)/(1:n),pch=".",col="blue")
#----------------------- question 4 -----------------------------------
iH <- sort(H)
points(1:n,cumsum(iH>110)/(1:n),pch=".",col="green")
#----------------------- question 5 -----------------------------------
dH <- sort(H,decreasing=TRUE)
points(1:n,cumsum(dH>110)/(1:n),pch=".",col="red")